%ifarch %{ix86}
%global nosse2_hack 1
## TODO:
# * consider debian's approach of runtime detection instead:
#   https://codereview.qt-project.org/#/c/127354/
%endif

%define snapshot 0

%ifarch %{arm}
%define build_docs 0
%else
%define build_docs 1
%endif

%define qtmajor 5
%define qtminor 6
%define qtsubminor 2

%define rel 10
%define pre rc
%define qtversion %{qtmajor}.%{qtminor}.%{qtsubminor}

%define libqt5quicktest %mklibname qt5quicktest %qtmajor
%define libqt5quicktest_d %mklibname qt%{qtmajor}quicktest -d

%define libqt5quick %mklibname qt5quick %qtmajor
%define libqt5quick_d %mklibname qt%{qtmajor}quick -d

%define libqt5quickwidgets %mklibname qt5quickwidgets %qtmajor
%define libqt5quickwidgets_d %mklibname qt%{qtmajor}quickwidgets -d

%define libqt5quickparticles %mklibname qt5quickparticles %qtmajor
%define libqt5quickparticles_d %mklibname qt%{qtmajor}quickparticles -d

%define libqt5qml %mklibname qt5qml %qtmajor
%define libqt5qml_d %mklibname qt%{qtmajor}qml -d

%if %snapshot
%define qttarballdir qtdeclarative-opensource-src-%{qtversion}-%pre
%else
%define qttarballdir qtdeclarative-opensource-src-%{qtversion}
%endif

Name: qtdeclarative5
Version: %{qtversion}
Release: %mkrel %{rel}
Summary: Qt Declarative component
Group: Development/KDE and Qt
License: LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:     http://www.qt.io
Source0: http://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.gz
BuildRequires: pkgconfig(Qt5Xml)
BuildRequires: pkgconfig(Qt5XmlPatterns)
BuildRequires: qtcore5-devel = %{version}
BuildRequires: qtnetwork5-devel = %{version}
BuildRequires: qtgui5-devel = %{version}
BuildRequires: qtwidgets5-devel = %{version}
BuildRequires: qtsql5-devel = %{version}

BuildRequires: cmake(Qt5Test) = %{version}

Conflicts:     %{_lib}qt5qml-private-devel  < 5.5.0-3

#Branch Patchs
# support no_sse2 CONFIG (i586 builds cannot assume -march=pentium4 -msse2 -mfpmath=sse flags, or the JIT that needs them)
# https://codereview.qt-project.org/#change,73710
Patch1: qtdeclarative-opensource-src-5.6.2-no_sse2.patch

#Trunk Patchs
Patch100:  qtdeclarative-opensource-src-5.6.2-fix-QTBUG-46263.patch
#Patch from Mageia


%description
Qt5 Declarative component.

%files
%_qt5_bindir/qml
%_qt5_bindir/qmlimportscanner
%_qt5_bindir/qmlmin
%_qt5_bindir/qmlplugindump
%_qt5_bindir/qmlprofiler
%_qt5_bindir/qmlscene
%_qt5_bindir/qmltestrunner
%_qt5_bindir/qmleasing
%_qt5_bindir/qmllint
%_qt5_prefix/qml/QtTest
%_qt5_prefix/qml/QtQuick*
%_qt5_prefix/plugins/qmltooling/libqmldbg_tcp.so
%_qt5_prefix/plugins/qmltooling/libqmldbg_debugger.so
%_qt5_prefix/plugins/qmltooling/libqmldbg_inspector.so
%_qt5_prefix/plugins/qmltooling/libqmldbg_local.so
%_qt5_prefix/plugins/qmltooling/libqmldbg_native.so
%_qt5_prefix/plugins/qmltooling/libqmldbg_profiler.so
%_qt5_prefix/plugins/qmltooling/libqmldbg_server.so
%_qt5_prefix/qml/Qt/labs/folderlistmodel
%_qt5_prefix/qml/Qt/labs/settings
%_qt5_datadir/qml/QtQml
%_qt5_datadir/qml/builtins.qmltypes

#------------------------------------------------------------------------------

%if %{build_docs}
%package doc
Summary: QtDeclarative%{qtmajor} APIs and tools docs
Group:   Documentation
BuildArch: noarch
BuildRequires: qttools5
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires: qttools5-assistant
Recommends: qttools5-assistant

%description doc
Documentation for APIs and tools in QtDeclarative5 package for use with
Qt Assistant.

%files doc
%{_qt5_docdir}/qtqml.qch
%{_qt5_docdir}/qtqml/
%{_qt5_docdir}/qtquick.qch
%{_qt5_docdir}/qtquick/
%endif

#------------------------------------------------------------------------------

%package -n %{libqt5quicktest}
Summary: Qt%{qtmajor} Lib
Group: System/Libraries

%description -n %{libqt5quicktest}
Qt%{qtmajor} Lib.

%files -n %{libqt5quicktest}
%{_qt5_libdir}/libQt5QuickTest.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqt5quicktest_d}
Summary: Devel files needed to build apps based on QtDeclarative
Group:    Development/KDE and Qt
Requires: %{libqt5quicktest} = %version-%{release}
Requires: %{name} = %version
Provides: libqt5quicktest-devel = %version-%{release}
Provides: libqtquicktest5-devel = %version-%{release}
Provides: qt5quicktest-devel = %version-%{release}
Provides: qtquicktest5-devel = %version-%{release}

Provides: libqt5quicktest-private-devel = %version-%{release}
Provides: libqtquicktest5-private-devel = %version-%{release}
Provides: qt5quicktest-private-devel = %version-%{release}
Provides: qtquicktest5-private-devel = %version-%{release}

%description -n %{libqt5quicktest_d}
Devel files needed to build apps based on QtDeclarative.

%files -n %{libqt5quicktest_d}
%_qt5_libdir/libQt5QuickTest.prl
%_qt5_libdir/libQt5QuickTest.so
%_qt5_libdir/cmake/Qt5QuickTest
%_qt5_includedir/QtQuickTest
%_qt5_libdir/pkgconfig/Qt5QuickTest.pc
%_qt5_prefix/examples/qmltest

#------------------------------------------------------------------------------

%package -n %{libqt5quick}
Summary: Qt%{qtmajor} Lib
Group: System/Libraries

%description -n %{libqt5quick}
Qt%{qtmajor} Lib.

%files -n %{libqt5quick}
%{_qt5_libdir}/libQt5Quick.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqt5quick_d}
Summary: Devel files needed to build apps based on QtDeclarative
Group:    Development/KDE and Qt
Requires: %{name} = %version-%{release}
Requires: %{libqt5quick} = %version-%{release}
Provides: libqt5quick-devel = %version-%{release}
Provides: libqtquick5-devel = %version-%{release}
Provides: qt5quick-devel = %version-%{release}
Provides: qtquick5-devel = %version-%{release}
Requires: qtgui5-devel = %version-%{release}

Provides: libqt5quick-private-devel = %version-%{release}
Provides: libqtquick5-private-devel = %version-%{release}
Provides: qt5quick-private-devel = %version-%{release}
Provides: qtquick5-private-devel = %version-%{release}

%description -n %{libqt5quick_d}
Devel files needed to build apps based on QtDeclarative.

%files -n %{libqt5quick_d}
%_qt5_libdir/libQt5Quick.prl
%_qt5_libdir/libQt5Quick.so
%_qt5_libdir/cmake/Qt5Quick
%_qt5_includedir/QtQuick
%_qt5_prefix/examples/quick
%_qt5_libdir/pkgconfig/Qt5Quick.pc
%_qt5_prefix/mkspecs/modules/qt_lib_quick.pri
%_qt5_prefix/mkspecs/modules/qt_lib_quick_private.pri

#------------------------------------------------------------------------------

%package -n %{libqt5quickwidgets}
Summary: Qt%{qtmajor} Lib 
Group: System/Libraries

%description -n %{libqt5quickwidgets}
Qt%{qtmajor} Lib.

%files -n %{libqt5quickwidgets}
%{_qt5_libdir}/libQt5QuickWidgets.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqt5quickwidgets_d}
Summary: Devel files needed to build apps based on QtDeclarative
Group:    Development/KDE and Qt
Requires: %{name} = %version-%{release}
Requires: %{libqt5quickwidgets} = %version-%{release}
Provides: libqt5quickwidgets-devel = %version-%{release}
Provides: libqtquickwidgets5-devel = %version-%{release}
Provides: qt5quickwidgets-devel = %version-%{release}
Provides: qtquickwidgets5-devel = %version-%{release}

Provides: libqt5quickwidgets-private-devel = %version-%{release}
Provides: libqtquickwidgets5-private-devel = %version-%{release}
Provides: qt5quickwidgets-private-devel = %version-%{release}
Provides: qtquickwidgets5-private-devel = %version-%{release}

%description -n %{libqt5quickwidgets_d}
Devel files needed to build apps based on QtDeclarative.

%files -n %{libqt5quickwidgets_d}
%_qt5_libdir/libQt5QuickWidgets.prl
%_qt5_libdir/libQt5QuickWidgets.so
%_qt5_libdir/cmake/Qt5QuickWidgets
%_qt5_includedir/QtQuickWidgets
%_qt5_libdir/pkgconfig/Qt5QuickWidgets.pc
%_qt5_prefix/mkspecs/modules/qt_lib_quickwidgets.pri
%_qt5_prefix/mkspecs/modules/qt_lib_quickwidgets_private.pri

#------------------------------------------------------------------------------

%package -n %{libqt5quickparticles}
Summary: Qt%{qtmajor} Lib
Group: System/Libraries

%description -n %{libqt5quickparticles}
Qt%{qtmajor} Lib.

%files -n %{libqt5quickparticles}
%{_qt5_libdir}/libQt5QuickParticles.so.%{qtmajor}*

#------------------------------------------------------------------------------

%package -n %{libqt5quickparticles_d}
Summary: Devel files needed to build apps based on QtDeclarative
Group:    Development/KDE and Qt
Requires: %{name} = %version-%{release}
Requires: %{libqt5quickparticles} = %version-%{release}
Provides: libqt5quickparticles-devel = %version-%{release}
Provides: libqtquickparticles5-devel = %version-%{release}
Provides: qt5quickparticles-devel = %version-%{release}
Provides: qtquickparticles5-devel = %version-%{release}

Provides: libqt5quickparticles-private-devel = %version-%{release}
Provides: libqtquickparticles5-private-devel = %version-%{release}
Provides: qt5quickparticles-private-devel = %version-%{release}
Provides: qtquickparticles5-private-devel = %version-%{release}

%description -n %{libqt5quickparticles_d}
Devel files needed to build apps based on QtDeclarative.

%files -n %{libqt5quickparticles_d}
%_qt5_libdir/libQt5QuickParticles.prl
%_qt5_libdir/libQt5QuickParticles.so
%_qt5_includedir/QtQuickParticles
%_qt5_prefix/mkspecs/modules/qt_lib_quickparticles_private.pri

#------------------------------------------------------------------------------

%package -n %{libqt5qml}
Summary: Qt%{qtmajor} Lib
Group: System/Libraries

%description -n %{libqt5qml}
Qt%{qtmajor} Lib.

%files -n %{libqt5qml}
%{_qt5_libdir}/libQt5Qml.so.%{qtmajor}*

%if 0%{?nosse2_hack}
%{_qt5_libdir}/sse2/libQt5Qml.so.%{qtmajor}*
%endif

#------------------------------------------------------------------------------

%package -n %{libqt5qml_d}
Summary: Devel files needed to build apps based on QtDeclarative
Group:    Development/KDE and Qt
Requires: %{name} = %version-%{release}
Requires: %{libqt5qml} = %version-%{release}
Provides: libqt5qml-devel = %version-%{release}
Provides: libqtqml5-devel = %version-%{release}
Provides: qt5qml-devel = %version-%{release}
Provides: qtqml5-devel = %version-%{release}

Provides: libqt5qml-private-devel = %version-%{release}
Provides: libqtqml5-private-devel = %version-%{release}
Provides: qt5qml-private-devel = %version-%{release}
Provides: qtqml5-private-devel = %version-%{release}

Requires: qtnetwork5-devel = %version
Requires: qtcore5-devel = %version

%description -n %{libqt5qml_d}
Devel files needed to build apps based on QtDeclarative.

%files -n %{libqt5qml_d}
%_qt5_libdir/libQt5Qml.prl
%_qt5_libdir/libQt5Qml.so
%_qt5_libdir/cmake/Qt5Qml
%_qt5_prefix/mkspecs/modules/qt_lib_qmltest.pri
%_qt5_prefix/mkspecs/modules/qt_lib_qml.pri
%_qt5_prefix/examples/qml
%_qt5_libdir/pkgconfig/Qt5Qml.pc
%_qt5_libdir/libQt5QmlDevTools.a
%_qt5_includedir/QtQml*
%_qt5_libdir/libQt5QmlDevTools.prl
%_qt5_prefix/mkspecs/modules/qt_lib_qml_private.pri
%_qt5_prefix/mkspecs/modules/qt_lib_qmldevtools_private.pri
%_qt5_prefix/mkspecs/modules/qt_lib_qmltest_private.pri

#------------------------------------------------------------------------------

%prep
%setup -q -n qtdeclarative-opensource-src-%{qtversion}

%if 0%{?nosse2_hack}
%patch1 -p1 -b .no_sse2
%endif

%patch100 -p1

%build
mkdir %{_target_platform}
pushd %{_target_platform}
%{qmake_qt5} ..
popd

%make_build -C %{_target_platform}

%if 0%{?nosse2_hack}
# build libQt5Qml with no_sse2
mkdir -p %{_target_platform}-no_sse2
pushd    %{_target_platform}-no_sse2
%{qmake_qt5} -config no_sse2 ..
%make_build sub-src-clean
%make_build -C src/qml
popd
%endif

%if %{build_docs}
%__make docs -C %{_target_platform}
%endif

%install
%make_install INSTALL_ROOT=%{buildroot} -C %{_target_platform}

%if 0%{?nosse2_hack}
mkdir -p %{buildroot}%{_qt5_libdir}/sse2
mv %{buildroot}%{_qt5_libdir}/libQt5Qml.so.5* %{buildroot}%{_qt5_libdir}/sse2/
%make_install INSTALL_ROOT=%{buildroot} -C %{_target_platform}-no_sse2/src/qml
%endif


%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot} -C %{_target_platform}
%endif

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete
#find %%{buildroot} -name '*.a' -delete






%changelog
* Wed Apr 12 2017 neoclust <neoclust> 5.6.2-10.mga6
+ Revision: 1096439
- Rebuild with fixed BR

* Tue Apr 11 2017 neoclust <neoclust> 5.6.2-9.mga6
+ Revision: 1096434
- Add P100 to fix kwin crashes

* Sun Apr 02 2017 neoclust <neoclust> 5.6.2-8.mga6
+ Revision: 1095681
- Try to fix install on i586
- Try to fix build on i586
- Fix typo in qmake
- fix non-sse2 support (kde#346244)
- Revert sync to branch, it does not fix our panel crash
- Add more build w/o see2

* Thu Mar 30 2017 neoclust <neoclust> 5.6.2-4.mga6
+ Revision: 1095262
- Rebuild as it failed in i586
- Sync with upstream 5.6 branch

* Thu Jan 12 2017 neoclust <neoclust> 5.6.2-2.mga6
+ Revision: 1081189
- Disable ss2 on i586

* Thu Nov 03 2016 neoclust <neoclust> 5.6.2-1.mga6
+ Revision: 1064913
- New version 5.6.2

* Fri Sep 02 2016 daviddavid <daviddavid> 5.6.1-3.mga6
+ Revision: 1049777
- build missing docs part (mga#9812)
- add qtdeclarative5-doc subpackage

* Sun Jul 03 2016 neoclust <neoclust> 5.6.1-2.mga6
+ Revision: 1038370
- Update to version 5.6.1-1
- New version

* Fri Mar 18 2016 neoclust <neoclust> 5.6.0-2.mga6
+ Revision: 992739
- Fix release

* Wed Mar 16 2016 neoclust <neoclust> 5.6.0-1.rc.2.mga6
+ Revision: 992260
- New version

* Wed Mar 09 2016 neoclust <neoclust> 5.6.0-0.rc.2.mga6
+ Revision: 987887
- Rebuild Qt5 Stack to fix plasma crashes

* Sun Feb 28 2016 neoclust <neoclust> 5.6.0-0.rc.1.mga6
+ Revision: 980606
+ rebuild (emptylog)

* Sun Dec 27 2015 neoclust <neoclust> 5.6.0-0.beta.4.mga6
+ Revision: 915947
- Rebuild against new cmake to have cmake() provides

* Sun Dec 27 2015 neoclust <neoclust> 5.6.0-0.beta.3.mga6
+ Revision: 915788
- Rebuild against new cmake to have cmake() provides

* Sun Dec 20 2015 neoclust <neoclust> 5.6.0-0.beta.2.mga6
+ Revision: 912727
- Remove private devel packages

* Sat Dec 19 2015 neoclust <neoclust> 5.6.0-0.beta.1.mga6
+ Revision: 911865
- New version 5.6.0 beta

* Tue Nov 10 2015 neoclust <neoclust> 5.5.1-2.mga6
+ Revision: 900388
- Rebuild against fixed qtbase5

* Fri Oct 23 2015 neoclust <neoclust> 5.5.1-1.mga6
+ Revision: 894493
- New version

* Thu Oct 22 2015 neoclust <neoclust> 5.5.0-4.mga6
+ Revision: 894042
- Enforce release in requires/provides

* Mon Sep 28 2015 neoclust <neoclust> 5.5.0-3.mga6
+ Revision: 884329
- Fix file location ( mga#16779)

* Fri Aug 07 2015 sander85 <sander85> 5.5.0-2.mga6
+ Revision: 861527
- Add some BRs to build qt5-xmllistmodel support for yr.no plasmoid (BR from Fedora)

* Sun Jul 12 2015 filipesaraiva <filipesaraiva> 5.5.0-1.mga6
+ Revision: 853376
- Update to Qt 5.5.0 version;
- Fix URL to new address qt.io;
- Delete old sources;

* Wed Jun 24 2015 neoclust <neoclust> 5.5.0-0.rc.2.mga6
+ Revision: 841745
- Do not remove all .a files, they are needed by lupdate

* Mon Jun 22 2015 neoclust <neoclust> 5.5.0-0.rc.1.mga6
+ Revision: 839912
- New version 5.5 rc

* Tue Dec 16 2014 neoclust <neoclust> 5.4.0-2.mga5
+ Revision: 803482
- Fix requires on name

* Fri Dec 12 2014 neoclust <neoclust> 5.4.0-1.mga5
+ Revision: 802784
- New version 5.4.0

* Sun Dec 07 2014 neoclust <neoclust> 5.3.2-1.mga5
+ Revision: 801797
- New version 5.3.2

* Wed Oct 15 2014 umeabot <umeabot> 5.3.1-3.mga5
+ Revision: 747462
- Second Mageia 5 Mass Rebuild

* Sun Oct 12 2014 umeabot <umeabot> 5.3.1-2.mga5
+ Revision: 738087
- Mageia 5 Mass Rebuild

* Thu Jun 26 2014 fwang <fwang> 5.3.1-1.mga5
+ Revision: 639772
- 5.3.1

* Tue May 20 2014 fwang <fwang> 5.3.0-1.mga5
+ Revision: 624068
- 5.3.0 final

* Fri May 09 2014 fwang <fwang> 5.3.0-0.rc.1.mga5
+ Revision: 621412
- update file list
- 5.3.0 rc

* Sun Apr 06 2014 fwang <fwang> 5.3.0-0.beta.1.mga5
+ Revision: 612293
- 5.3.0beta
- 5.3.0 beta

* Mon Mar 03 2014 neoclust <neoclust> 5.3.0-0.alpha.1.mga5
+ Revision: 598825
- New version 5.3.0-alpha

* Sun Feb 09 2014 fwang <fwang> 5.2.1-2.mga5
+ Revision: 586965
- hard force versioned requires

* Thu Feb 06 2014 fwang <fwang> 5.2.1-1.mga5
+ Revision: 584209
- 5.2.1

* Sat Dec 14 2013 fwang <fwang> 5.2.0-2.mga4
+ Revision: 556731
- 5.2.0 final

* Sun Dec 01 2013 fwang <fwang> 5.2.0-1.rc1.1.mga4
+ Revision: 554429
- update file list
- 5.2.0 rc1

* Thu Nov 14 2013 fwang <fwang> 5.2.0-1.beta1.2.mga4
+ Revision: 551124
- qtjsbackend is not needed now

* Sat Oct 26 2013 fwang <fwang> 5.2.0-1.beta1.1.mga4
+ Revision: 547096
- 5.2.0 beta1
- 5.2.0 beta1

* Mon Oct 21 2013 umeabot <umeabot> 5.2.0-1.alpha.3.mga4
+ Revision: 538997
- Mageia 4 Mass Rebuild

* Fri Oct 04 2013 fwang <fwang> 5.2.0-1.alpha.2.mga4
+ Revision: 491188
- add requires on qml-private-devel, as there are relative includes

* Wed Oct 02 2013 neoclust <neoclust> 5.2.0-1.alpha.1.mga4
+ Revision: 490485
- New version 5.2.0 alpha

* Mon May 27 2013 neoclust <neoclust> 5.2.0-0.0.20130523.2.mga4
+ Revision: 428816
- Rebuild against new qt5 libs location

* Sat May 25 2013 neoclust <neoclust> 5.2.0-0.0.20130523.1.mga4
+ Revision: 427023
- New QT 5.2 Snapshot

* Wed Apr 17 2013 neoclust <neoclust> 5.0.2-1.mga3
+ Revision: 410360
- New version 5.0.2

* Sat Feb 02 2013 neoclust <neoclust> 5.0.1-1.mga3
+ Revision: 394038
- New version 5.O.1 Final

* Tue Jan 29 2013 neoclust <neoclust> 5.0.1-0.rc1.2.mga3
+ Revision: 393093
- Move private headers out of devel package

* Sat Jan 26 2013 neoclust <neoclust> 5.0.1-0.rc1.1.mga3
+ Revision: 392326
- New version 5.0.1 rc1

* Sat Jan 26 2013 neoclust <neoclust> 5.0.0-2.mga3
+ Revision: 392305
- Fix typo in macro
- imported package qtdeclarative5

